View Issue Details

IDProjectCategoryView StatusLast Update
0011777FPCCompilerpublic2011-12-01 11:24
ReporterMicha Nelissen Assigned ToFlorian  
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
Product Version2.3.1 
Fixed in Version2.6.0 
Summary0011777: Generics template needs Self type reference
DescriptionTo implement TFPGList.Assign, I need a to be able to reference to a specialized TFPGList of the same type.

It's the generic equivalent of:

TList = class
  procedure Assign(Source: TList);
end;

See, I can reference to TList here although it's not fully declared yet.

The compiler now complains with:

fgl.pp(110,38) Error: Generics without specialization can not be used as a type for a variable
Tagsgenerics
Fixed in Revision16432
FPCOldBugId0
FPCTarget
Attached Files

Relationships

related to 0015477 closedFlorian Parser Error? concerning generic classes 
child of 0010479 closedFlorian TFPGList<T>.Assign(TFPGList) is not implemented 

Activities

Micha Nelissen

2008-08-01 20:43

manager   ~0021028

I've added a test case: test/tgeneric17.pp

2010-11-17 22:42

 

fpc_bug_11777_generics_self_reference.patch (83,599 bytes)   
Index: compiler/fmodule.pas
===================================================================
--- compiler/fmodule.pas	(revision 16356)
+++ compiler/fmodule.pas	(working copy)
@@ -579,6 +579,8 @@
               begin
                 current_procinfo:=nil;
                 current_objectdef:=nil;
+                current_genericdef:=nil;
+                current_specializedef:=nil;
               end;
             { release procinfo tree }
             while assigned(procinfo) do
@@ -659,6 +661,8 @@
               begin
                 current_procinfo:=nil;
                 current_objectdef:=nil;
+                current_genericdef:=nil;
+                current_specializedef:=nil;
               end;
             { release procinfo tree }
             while assigned(procinfo) do
Index: compiler/msg/errore.msg
===================================================================
--- compiler/msg/errore.msg	(revision 16356)
+++ compiler/msg/errore.msg	(working copy)
@@ -1336,6 +1336,11 @@
 % procedural variable contains a reference to a nested procedure/function.
 % Therefore such typed constants can only be initialized with global
 % functions/procedures since these do not require a parent frame pointer.
+parser_f_no_generic_inside_generic=03297_F_Declaration of generic class inside another generic class is not allowed
+% At the moment, scanner supports recording of only one token buffer at the time
+% (guarded by internal error 200511173 in tscannerfile.startrecordtokens).
+% Since generics are implemented by recording tokens, it is not possible to
+% have declaration of generic class inside another generic class.
 % \end{description}
 #
 # Type Checking
Index: compiler/msgidx.inc
===================================================================
--- compiler/msgidx.inc	(revision 16356)
+++ compiler/msgidx.inc	(working copy)
@@ -385,6 +385,7 @@
   parser_e_objc_enumerator_2_0=03294;
   parser_e_objc_missing_enumeration_defs=03295;
   parser_e_no_procvarnested_const=03296;
+  parser_f_no_generic_inside_generic=03297;
   type_e_mismatch=04000;
   type_e_incompatible_types=04001;
   type_e_not_equal_types=04002;
@@ -870,9 +871,9 @@
   option_info=11024;
   option_help_pages=11025;
 
-  MsgTxtSize = 57808;
+  MsgTxtSize = 57889;
 
   MsgIdxMax : array[1..20] of longint=(
-    24,88,297,97,82,54,111,22,202,63,
+    24,88,298,97,82,54,111,22,202,63,
     49,20,1,1,1,1,1,1,1,1
   );
Index: compiler/msgtxt.inc
===================================================================
--- compiler/msgtxt.inc	(revision 16356)
+++ compiler/msgtxt.inc	(working copy)
@@ -1,7 +1,7 @@
 {$ifdef Delphi}
-const msgtxt : array[0..000240] of string[240]=(
+const msgtxt : array[0..000241] of string[240]=(
 {$else Delphi}
-const msgtxt : array[0..000240,1..240] of char=(
+const msgtxt : array[0..000241,1..240] of char=(
 {$endif Delphi}
   '01000_T_Compiler: $1'#000+
   '01001_D_Compiler OS: $1'#000+
@@ -463,406 +463,409 @@
   'stEnumerationState type in the C','ocoaAll unit'#000+
   '03296_E_Typed constants of the type '#039'procedure is nested'#039' can '+
   'only be initialized with NIL and global procedures/functions'#000+
+  '03297_F_Declaration of generic class inside another generic class is n'+
+  'ot allowed'#000+
   '04000_E_Type mismatch'#000+
-  '04001_E_Incompatible types: got "$1" expected "$2"'#000+
-  '04002_E_Type mismatch between "','$1" and "$2"'#000+
+  '0','4001_E_Incompatible types: got "$1" expected "$2"'#000+
+  '04002_E_Type mismatch between "$1" and "$2"'#000+
   '04003_E_Type identifier expected'#000+
   '04004_E_Variable identifier expected'#000+
   '04005_E_Integer expression expected, but got "$1"'#000+
-  '04006_E_Boolean expression expected, but got "$1"'#000+
+  '04006_E_Boolean expression',' expected, but got "$1"'#000+
   '04007_E_Ordinal expression expected'#000+
-  '04008_E_pointer type ','expected, but got "$1"'#000+
+  '04008_E_pointer type expected, but got "$1"'#000+
   '04009_E_class type expected, but got "$1"'#000+
   '04011_E_Can'#039't evaluate constant expression'#000+
   '04012_E_Set elements are not compatible'#000+
-  '04013_E_Operation not implemented for sets'#000+
-  '04014_W_Automatic type conversion from floating t','ype to COMP which i'+
-  's an integer type'#000+
+  '04013_E_Ope','ration not implemented for sets'#000+
+  '04014_W_Automatic type conversion from floating type to COMP which is '+
+  'an integer type'#000+
   '04015_H_use DIV instead to get an integer result'#000+
   '04016_E_String types have to match exactly in $V+ mode'#000+
-  '04017_E_succ or pred on enums with assignments not possible'#000+
-  '04018_E_Can'#039't read or write variables o','f this type'#000+
+  '04017_E_succ or pr','ed on enums with assignments not possible'#000+
+  '04018_E_Can'#039't read or write variables of this type'#000+
   '04019_E_Can'#039't use readln or writeln on typed file'#000+
   '04020_E_Can'#039't use read or write on untyped file.'#000+
   '04021_E_Type conflict between set elements'#000+
-  '04022_W_lo/hi(dword/qword) returns the upper/lower word/dword'#000+
-  '04023_E_Integer or real ','expression expected'#000+
+  '04022','_W_lo/hi(dword/qword) returns the upper/lower word/dword'#000+
+  '04023_E_Integer or real expression expected'#000+
   '04024_E_Wrong type "$1" in array constructor'#000+
   '04025_E_Incompatible type for arg no. $1: Got "$2", expected "$3"'#000+
-  '04026_E_Method (variable) and Procedure (variable) are not compatible'#000+
-  '04027_E_Illegal constant passed to inte','rnal math function'#000+
+  '04026_E_Method (variable) an','d Procedure (variable) are not compatibl'+
+  'e'#000+
+  '04027_E_Illegal constant passed to internal math function'#000+
   '04028_E_Can'#039't take the address of constant expressions'#000+
   '04029_E_Argument can'#039't be assigned to'#000+
-  '04030_E_Can'#039't assign local procedure/function to procedure variabl'+
-  'e'#000+
+  '04030_E_Can'#039't assign local procedure/function t','o procedure varia'+
+  'ble'#000+
   '04031_E_Can'#039't assign values to an address'#000+
-  '04032_E_Can'#039't assi','gn values to const variable'#000+
+  '04032_E_Can'#039't assign values to const variable'#000+
   '04033_E_Array type required'#000+
   '04034_E_interface type expected, but got "$1"'#000+
-  '04035_H_Mixing signed expressions and longwords gives a 64bit result'#000+
-  '04036_W_Mixing signed expressions and cardinals here may cause a rang',
-  'e check error'#000+
+  '04035_H_Mixing signed expressions and longwords gives a 6','4bit result'+
+  #000+
+  '04036_W_Mixing signed expressions and cardinals here may cause a range'+
+  ' check error'#000+
   '04037_E_Typecast has different size ($1 -> $2) in assignment'#000+
   '04038_E_enums with assignments can'#039't be used as array index'#000+
-  '04039_E_Class or Object types "$1" and "$2" are not related'#000+
-  '04040_W_Class types "$1" and "$2" are not rel','ated'#000+
+  '04039_E_Class or Object ','types "$1" and "$2" are not related'#000+
+  '04040_W_Class types "$1" and "$2" are not related'#000+
   '04041_E_Class or interface type expected, but got "$1"'#000+
   '04042_E_Type "$1" is not completely defined'#000+
-  '04043_W_String literal has more characters than short string length'#000+
+  '04043_W_String literal has more characters than short s','tring length'#000+
   '04044_W_Comparison is always false due to range of values'#000+
-  '04045_W_Co','mparison is always true due to range of values'#000+
+  '04045_W_Comparison is always true due to range of values'#000+
   '04046_W_Constructing a class "$1" with abstract method "$2"'#000+
-  '04047_H_The left operand of the IN operator should be byte sized'#000+
-  '04048_W_Type size mismatch, possible loss of data / range check erro','r'+
-  #000+
+  '04047_H_The left operand of the IN operator should b','e byte sized'#000+
+  '04048_W_Type size mismatch, possible loss of data / range check error'#000+
   '04049_H_Type size mismatch, possible loss of data / range check error'#000+
   '04050_E_The address of an abstract method can'#039't be taken'#000+
-  '04051_E_Assignments to formal parameters and open arrays are not possi'+
-  'ble'#000+
-  '04052_E_Constant Expression expected'#000,
+  '04051_E_Assignments to formal ','parameters and open arrays are not pos'+
+  'sible'#000+
+  '04052_E_Constant Expression expected'#000+
   '04053_E_Operation "$1" not supported for types "$2" and "$3"'#000+
   '04054_E_Illegal type conversion: "$1" to "$2"'#000+
-  '04055_H_Conversion between ordinals and pointers is not portable'#000+
+  '04055_H_Conversion between ordinals and pointers is ','not portable'#000+
   '04056_W_Conversion between ordinals and pointers is not portable'#000+
-  '040','57_E_Can'#039't determine which overloaded function to call'#000+
+  '04057_E_Can'#039't determine which overloaded function to call'#000+
   '04058_E_Illegal counter variable'#000+
   '04059_W_Converting constant real value to double for C variable argume'+
-  'nt, add explicit typecast to prevent this.'#000+
-  '04060_E_Class or COM interface type exp','ected, but got "$1"'#000+
+  'n','t, add explicit typecast to prevent this.'#000+
+  '04060_E_Class or COM interface type expected, but got "$1"'#000+
   '04061_E_Constant packed arrays are not yet supported'#000+
   '04062_E_Incompatible type for arg no. $1: Got "$2" expected "(Bit)Pack'+
   'ed Array"'#000+
-  '04063_E_Incompatible type for arg no. $1: Got "$2" expected "(not pack'+
-  'ed) Array"'#000+
-  '04064_','E_Elements of packed arrays cannot be of a type which need to '+
-  'be initialised'#000+
+  '04063_','E_Incompatible type for arg no. $1: Got "$2" expected "(not pa'+
+  'cked) Array"'#000+
+  '04064_E_Elements of packed arrays cannot be of a type which need to be'+
+  ' initialised'#000+
   '04065_E_Constant packed records and objects are not yet supported'#000+
-  '04066_W_Arithmetic "$1" on untyped pointer is unportable to {$T+}, sug'+
-  'gest typecast'#000+
-  '04076_E_Can'#039't',' take address of a subroutine marked as local'#000+
+  '04066_W_Arithmet','ic "$1" on untyped pointer is unportable to {$T+}, s'+
+  'uggest typecast'#000+
+  '04076_E_Can'#039't take address of a subroutine marked as local'#000+
   '04077_E_Can'#039't export subroutine marked as local from a unit'#000+
   '04078_E_Type is not automatable: "$1"'#000+
-  '04079_H_Converting the operands to "$1" before doing the add could pre'+
-  'vent overflow errors.'#000+
-  '0408','0_H_Converting the operands to "$1" before doing the subtract co'+
+  '04079_H_Convert','ing the operands to "$1" before doing the add could p'+
+  'revent overflow errors.'#000+
+  '04080_H_Converting the operands to "$1" before doing the subtract coul'+
+  'd prevent overflow errors.'#000+
+  '04081_H_Converting the operands to "$1" before doing the multiply ','co'+
   'uld prevent overflow errors.'#000+
-  '04081_H_Converting the operands to "$1" before doing the multiply coul'+
-  'd prevent overflow errors.'#000+
-  '04082_W_Converting pointers to signed integers may',' result in wrong c'+
-  'omparison results and range errors, use an unsigned type instead.'#000+
+  '04082_W_Converting pointers to signed integers may result in wrong com'+
+  'parison results and range errors, use an unsigned type instead.'#000+
   '04083_E_Interface type $1 has no valid GUID'#000+
-  '04084_E_Invalid selector name "$1"'#000+
+  '04084_E_Invalid selector name "','$1"'#000+
   '04085_E_Expected Objective-C method, but got $1'#000+
-  '04086_E_Expected Objective-C ','method or constant method name'#000+
+  '04086_E_Expected Objective-C method or constant method name'#000+
   '04087_E_No type info available for this type'#000+
   '04088_E_Ordinal or string expression expected'#000+
   '04089_E_String expression expected'#000+
-  '04090_W_Converting 0 to NIL'#000+
-  '04091_E_Objective-C protocol type expected, but got "$1','"'#000+
+  '04','090_W_Converting 0 to NIL'#000+
+  '04091_E_Objective-C protocol type expected, but got "$1"'#000+
   '04092_E_The type "$1" is not supported for interaction with the Object'+
   'ive-C runtime.'#000+
   '04093_E_Class or objcclass type expected, but got "$1"'#000+
-  '04094_E_Objcclass type expected'#000+
-  '04095_W_Coerced univ parameter type in procedural variable may cau','se'+
-  ' crash or memory corruption: $1 to $2'#000+
+  '04094_E_Objcclass',' type expected'#000+
+  '04095_W_Coerced univ parameter type in procedural variable may cause c'+
+  'rash or memory corruption: $1 to $2'#000+
   '04096_E_Type parameters of specializations of generics cannot referenc'+
   'e the currently specialized type'#000+
-  '05000_E_Identifier not found "$1"'#000+
+  '05000_E_Identifi','er not found "$1"'#000+
   '05001_F_Internal Error in SymTableStack()'#000+
-  '05002_E_Duplicate ide','ntifier "$1"'#000+
+  '05002_E_Duplicate identifier "$1"'#000+
   '05003_H_Identifier already defined in $1 at line $2'#000+
   '05004_E_Unknown identifier "$1"'#000+
   '05005_E_Forward declaration not solved "$1"'#000+
-  '05007_E_Error in type definition'#000+
+  '05007_E_Error in t','ype definition'#000+
   '05009_E_Forward type not resolved "$1"'#000+
-  '05010_E_Only static variabl','es can be used in static methods or outsi'+
-  'de methods'#000+
+  '05010_E_Only static variables can be used in static methods or outside'+
+  ' methods'#000+
   '05012_F_record or class type expected'#000+
-  '05013_E_Instances of classes or objects with an abstract method are no'+
-  't allowed'#000+
+  '05013_E_Instances of classes or objects with an abstract method are n',
+  'ot allowed'#000+
   '05014_W_Label not defined "$1"'#000+
-  '05015_E_Label used but not defined "$1"',#000+
+  '05015_E_Label used but not defined "$1"'#000+
   '05016_E_Illegal label declaration'#000+
   '05017_E_GOTO and LABEL are not supported (use switch -Sg)'#000+
   '05018_E_Label not found'#000+
   '05019_E_identifier isn'#039't a label'#000+
-  '05020_E_label already defined'#000+
+  '05020_E_l','abel already defined'#000+
   '05021_E_illegal type declaration of set elements'#000+
-  '05022_E_For','ward class definition not resolved "$1"'#000+
+  '05022_E_Forward class definition not resolved "$1"'#000+
   '05023_H_Unit "$1" not used in $2'#000+
   '05024_H_Parameter "$1" not used'#000+
   '05025_N_Local variable "$1" not used'#000+
-  '05026_H_Value parameter "$1" is assigned but never used'#000+
-  '05027_N_Local variable "$1" is assigned bu','t never used'#000+
+  '05026_H_Value par','ameter "$1" is assigned but never used'#000+
+  '05027_N_Local variable "$1" is assigned but never used'#000+
   '05028_H_Local $1 "$2" is not used'#000+
   '05029_N_Private field "$1.$2" is never used'#000+
   '05030_N_Private field "$1.$2" is assigned but never used'#000+
-  '05031_N_Private method "$1.$2" never used'#000+
+  '05031_N_Pri','vate method "$1.$2" never used'#000+
   '05032_E_Set type expected'#000+
-  '05033_W_Function result ','does not seem to be set'#000+
+  '05033_W_Function result does not seem to be set'#000+
   '05034_W_Type "$1" is not aligned correctly in current record for C'#000+
   '05035_E_Unknown record field identifier "$1"'#000+
-  '05036_W_Local variable "$1" does not seem to be initialized'#000+
-  '05037_W_Variable "$1" does not seem to be in','itialized'#000+
+  '05036_W_Local variable ','"$1" does not seem to be initialized'#000+
+  '05037_W_Variable "$1" does not seem to be initialized'#000+
   '05038_E_identifier idents no member "$1"'#000+
   '05039_H_Found declaration: $1'#000+
   '05040_E_Data element too large'#000+
-  '05042_E_No matching implementation for interface method "$1" found'#000+
+  '05042_E_No matching implementation for interfac','e method "$1" found'#000+
   '05043_W_Symbol "$1" is deprecated'#000+
-  '05044_W_Symbol "$1" is not ','portable'#000+
+  '05044_W_Symbol "$1" is not portable'#000+
   '05055_W_Symbol "$1" is not implemented'#000+
   '05056_E_Can'#039't create unique type from this type'#000+
   '05057_H_Local variable "$1" does not seem to be initialized'#000+
-  '05058_H_Variable "$1" does not seem to be initialized'#000+
-  '05059_W_Function result variab','le does not seem to initialized'#000+
+  '050','58_H_Variable "$1" does not seem to be initialized'#000+
+  '05059_W_Function result variable does not seem to initialized'#000+
   '05060_H_Function result variable does not seem to be initialized'#000+
   '05061_W_Variable "$1" read but nowhere assigned'#000+
-  '05062_H_Found abstract method: $1'#000+
+  '05062_H_Found ','abstract method: $1'#000+
   '05063_W_Symbol "$1" is experimental'#000+
-  '05064_W_Forward declarati','on "$1" not resolved, assumed external'#000+
+  '05064_W_Forward declaration "$1" not resolved, assumed external'#000+
   '05065_W_Symbol "$1" is belongs to a library'#000+
   '05066_W_Symbol "$1" is deprecated: "$2"'#000+
-  '05067_E_Cannot find an enumerator for the type "$1"'#000+
+  '05067_E_Cannot find an enumerator fo','r the type "$1"'#000+
   '05068_E_Cannot find a "MoveNext" method in enumerator "$1"'#000+
-  '05069_','E_Cannot find a "Current" property in enumerator "$1"'#000+
+  '05069_E_Cannot find a "Current" property in enumerator "$1"'#000+
   '05070_E_Mismatch between number of declared parameters and number of c'+
   'olons in message string.'#000+
-  '05071_N_Private type "$1.$2" never used'#000+
+  '05071_N_Pr','ivate type "$1.$2" never used'#000+
   '05072_N_Private const "$1.$2" never used'#000+
-  '05073_N_Pr','ivate property "$1.$2" never used'#000+
+  '05073_N_Private property "$1.$2" never used'#000+
   '05074_W_Unit "$1" is deprecated'#000+
   '05075_W_Unit "$1" is deprecated: "$2"'#000+
   '05076_W_Unit "$1" is not portable'#000+
-  '05077_W_Unit "$1" is belongs to a library'#000+
+  '05077_W_Unit "$1" is ','belongs to a library'#000+
   '05078_W_Unit "$1" is not implemented'#000+
-  '05079_W_Unit "$1" is ex','perimental'#000+
+  '05079_W_Unit "$1" is experimental'#000+
   '05080_E_No complete definition of the formally declared objcclass "$1"'+
   ' is in scope'#000+
-  '05081_E_Gotos into initialization or finalization blocks of units are '+
-  'not allowed'#000+
+  '05081_E_Gotos into initialization or finalization blocks of units',' ar'+
+  'e not allowed'#000+
   '06009_E_Parameter list size exceeds 65535 bytes'#000+
-  '06012_E_File typ','es must be var parameters'#000+
+  '06012_E_File types must be var parameters'#000+
   '06013_E_The use of a far pointer isn'#039't allowed there'#000+
   '06015_E_EXPORT declared functions can'#039't be called'#000+
-  '06016_W_Possible illegal call of constructor or destructor'#000+
+  '06016_W_Possible illegal call ','of constructor or destructor'#000+
   '06017_N_Inefficient code'#000+
   '06018_W_unreachable code'#000+
-  '06','020_E_Abstract methods can'#039't be called directly'#000+
+  '06020_E_Abstract methods can'#039't be called directly'#000+
   '06027_DL_Register $1 weight $2 $3'#000+
   '06029_DL_Stack frame is omitted'#000+
-  '06031_E_Object or class methods can'#039't be inline.'#000+
+  '06031_E_Object or class methods can'#039't be inli','ne.'#000+
   '06032_E_Procvar calls cannot be inline.'#000+
-  '06033_E_No code for inline procedure ','stored'#000+
+  '06033_E_No code for inline procedure stored'#000+
   '06035_E_Element zero of an ansi/wide- or longstring can'#039't be acces'+
   'sed, use (set)length instead'#000+
-  '06037_E_Constructors or destructors cannot be called inside a '#039'wit'+
-  'h'#039' clause'#000+
+  '06037_E_Constructors or destructors cannot be called insi','de a '#039'w'+
+  'ith'#039' clause'#000+
   '06038_E_Cannot call message handler methods directly'#000+
-  '06039_E_J','ump in or outside of an exception block'#000+
+  '06039_E_Jump in or outside of an exception block'#000+
   '06040_E_Control flow statements aren'#039't allowed in a finally block'#000+
-  '06041_W_Parameters size exceeds limit for certain cpu'#039's'#000+
+  '06041_W_Parameters size exceeds limit for certain cpu',#039's'#000+
   '06042_W_Local variable size exceed limit for certain cpu'#039's'#000+
-  '06043_E_Local varia','bles size exceeds supported limit'#000+
+  '06043_E_Local variables size exceeds supported limit'#000+
   '06044_E_BREAK not allowed'#000+
   '06045_E_CONTINUE not allowed'#000+
-  '06046_F_Unknown compilerproc "$1". Check if you use the correct run ti'+
+  '06046_F_Unknown compilerproc "$1". Check if you use the correct run ti',
   'me library.'#000+
-  '06047_F_Cannot find system type "$1". Check if you use the correct ru',
-  'n time library.'#000+
+  '06047_F_Cannot find system type "$1". Check if you use the correct run'+
+  ' time library.'#000+
   '06048_H_Inherited call to abstract method ignored'#000+
   '06049_E_Goto label "$1" not defined or optimized away'#000+
-  '06050_F_Cannot find type "$1" in unit "$2". Check if you use the corre'+
-  'ct run time library.'#000+
-  '06051_E_Interprocedural gotos',' are allowed only to outer subroutines'#000+
+  '06050_F_Cannot find type "$1" in unit "','$2". Check if you use the cor'+
+  'rect run time library.'#000+
+  '06051_E_Interprocedural gotos are allowed only to outer subroutines'#000+
   '06052_E_Label must be defined in the same scope as it is declared'#000+
-  '06053_E_Leaving procedures containing explicit or implicit exceptions '+
-  'frames using goto is not allowed'#000+
-  '07000_DL_Starting $1 styled asse','mbler parsing'#000+
+  '06053_E_Leaving procedures containing explicit or impl','icit exception'+
+  's frames using goto is not allowed'#000+
+  '07000_DL_Starting $1 styled assembler parsing'#000+
   '07001_DL_Finished $1 styled assembler parsing'#000+
   '07002_E_Non-label pattern contains @'#000+
   '07004_E_Error building record offset'#000+
-  '07005_E_OFFSET used without identifier'#000+
+  '07005_E_OFFSET used witho','ut identifier'#000+
   '07006_E_TYPE used without identifier'#000+
-  '07007_E_Cannot use local varia','ble or parameters here'#000+
+  '07007_E_Cannot use local variable or parameters here'#000+
   '07008_E_need to use OFFSET here'#000+
   '07009_E_need to use $ here'#000+
   '07010_E_Cannot use multiple relocatable symbols'#000+
-  '07011_E_Relocatable symbol can only be added'#000+
+  '07011_E_Relocatable symbol ca','n only be added'#000+
   '07012_E_Invalid constant expression'#000+
-  '07013_E_Relocatable symbol is',' not allowed'#000+
+  '07013_E_Relocatable symbol is not allowed'#000+
   '07014_E_Invalid reference syntax'#000+
   '07015_E_You cannot reach $1 from that code'#000+
   '07016_E_Local symbols/labels aren'#039't allowed as references'#000+
-  '07017_E_Invalid base and index register usage'#000+
-  '07018_W_Possible error in object field handling',#000+
+  '07017_E_Inva','lid base and index register usage'#000+
+  '07018_W_Possible error in object field handling'#000+
   '07019_E_Wrong scale factor specified'#000+
   '07020_E_Multiple index register usage'#000+
   '07021_E_Invalid operand type'#000+
   '07022_E_Invalid string as opcode operand: $1'#000+
-  '07023_W_@CODE and @DATA not supported'#000+
+  '07023_W_@','CODE and @DATA not supported'#000+
   '07024_E_Null label references are not allowed'#000+
-  '07025_','E_Divide by zero in asm evaluator'#000+
+  '07025_E_Divide by zero in asm evaluator'#000+
   '07026_E_Illegal expression'#000+
   '07027_E_escape sequence ignored: $1'#000+
   '07028_E_Invalid symbol reference'#000+
-  '07029_W_Fwait can cause emulation problems with emu387'#000+
+  '07029_W_Fwait can cause emula','tion problems with emu387'#000+
   '07030_W_$1 without operand translated into $1P'#000+
-  '07031_W_','ENTER instruction is not supported by Linux kernel'#000+
+  '07031_W_ENTER instruction is not supported by Linux kernel'#000+
   '07032_W_Calling an overload function in assembler'#000+
   '07033_E_Unsupported symbol type for operand'#000+
-  '07034_E_Constant value out of bounds'#000+
+  '07034_E_Consta','nt value out of bounds'#000+
   '07035_E_Error converting decimal $1'#000+
-  '07036_E_Error converti','ng octal $1'#000+
+  '07036_E_Error converting octal $1'#000+
   '07037_E_Error converting binary $1'#000+
   '07038_E_Error converting hexadecimal $1'#000+
   '07039_H_$1 translated to $2'#000+
-  '07040_W_$1 is associated to an overloaded function'#000+
+  '07040_W_$1 is associated to an overloaded fu','nction'#000+
   '07041_E_Cannot use SELF outside a method'#000+
-  '07042_E_Cannot use OLDEBP outside',' a nested procedure'#000+
+  '07042_E_Cannot use OLDEBP outside a nested procedure'#000+
   '07043_W_Procedures can'#039't return any value in asm code'#000+
   '07044_E_SEG not supported'#000+
-  '07045_E_Size suffix and destination or source size do not match'#000+
+  '07045_E_Size suffix and destination or source size do not m','atch'#000+
   '07046_W_Size suffix and destination or source size do not match'#000+
-  '07047_E_Asse','mbler syntax error'#000+
+  '07047_E_Assembler syntax error'#000+
   '07048_E_Invalid combination of opcode and operands'#000+
   '07049_E_Assembler syntax error in operand'#000+
   '07050_E_Assembler syntax error in constant'#000+
-  '07051_E_Invalid String expression'#000+
-  '07052_W_constant with symbol $1 for address which i','s not on a pointe'+
-  'r'#000+
+  '0705','1_E_Invalid String expression'#000+
+  '07052_W_constant with symbol $1 for address which is not on a pointer'#000+
   '07053_E_Unrecognized opcode $1'#000+
   '07054_E_Invalid or missing opcode'#000+
   '07055_E_Invalid combination of prefix and opcode: $1'#000+
-  '07056_E_Invalid combination of override and opcode: $1'#000+
+  '07056_E_Invalid combin','ation of override and opcode: $1'#000+
   '07057_E_Too many operands on line'#000+
-  '07058_W_NEAR i','gnored'#000+
+  '07058_W_NEAR ignored'#000+
   '07059_W_FAR ignored'#000+
   '07060_E_Duplicate local symbol $1'#000+
   '07061_E_Undefined local symbol $1'#000+
   '07062_E_Unknown label identifier $1'#000+
-  '07063_E_Invalid register name'#000+
+  '07063_E_Invalid register nam','e'#000+
   '07064_E_Invalid floating point register name'#000+
   '07066_W_Modulo not supported'#000+
-  '07067','_E_Invalid floating point constant $1'#000+
+  '07067_E_Invalid floating point constant $1'#000+
   '07068_E_Invalid floating point expression'#000+
   '07069_E_Wrong symbol type'#000+
-  '07070_E_Cannot index a local var or parameter with a register'#000+
+  '07070_E_Cannot index a local var or parameter with a ','register'#000+
   '07071_E_Invalid segment override expression'#000+
-  '07072_W_Identifier $1 suppos','ed external'#000+
+  '07072_W_Identifier $1 supposed external'#000+
   '07073_E_Strings not allowed as constants'#000+
   '07074_No type of variable specified'#000+
   '07075_E_assembler code not returned to text section'#000+
-  '07076_E_Not a directive or local symbol $1'#000+
+  '07076_E_Not a dire','ctive or local symbol $1'#000+
   '07077_E_Using a defined name as a local label'#000+
-  '07078_E_Do','llar token is used without an identifier'#000+
+  '07078_E_Dollar token is used without an identifier'#000+
   '07079_W_32bit constant created for address'#000+
   '07080_N_.align is target specific, use .balign or .p2align'#000+
-  '07081_E_Can'#039't access fields directly for parameters'#000+
-  '07082_E_Can'#039't access fields of objects/classe','s directly'#000+
+  '07081_E_Can'#039't ac','cess fields directly for parameters'#000+
+  '07082_E_Can'#039't access fields of objects/classes directly'#000+
   '07083_E_No size specified and unable to determine the size of the oper'+
   'ands'#000+
   '07084_E_Cannot use RESULT in this function'#000+
-  '07086_W_"$1" without operand translated into "$1 %st,%st(1)"'#000+
-  '07087_W_"$1 %st(n)" translated into "$1 %st,%st(n)','"'#000+
+  '07086_W_"$1" without operand t','ranslated into "$1 %st,%st(1)"'#000+
+  '07087_W_"$1 %st(n)" translated into "$1 %st,%st(n)"'#000+
   '07088_W_"$1 %st(n)" translated into "$1 %st(n),%st"'#000+
   '07089_E_Char < not allowed here'#000+
   '07090_E_Char > not allowed here'#000+
   '07093_W_ALIGN not supported'#000+
-  '07094_E_Inc and Dec cannot be together'#000+
+  '07094_E_Inc a','nd Dec cannot be together'#000+
   '07095_E_Invalid reglist for movem'#000+
-  '07096_E_Reglist inval','id for opcode'#000+
+  '07096_E_Reglist invalid for opcode'#000+
   '07097_E_Higher cpu mode required ($1)'#000+
   '07098_W_No size specified and unable to determine the size of the oper'+
   'ands, using DWORD as default'#000+
-  '07099_E_Syntax error while trying to parse a shifter operand'#000+
-  '07100_E_Address of packed co','mponent is not at a byte boundary'#000+
+  '07099_E_','Syntax error while trying to parse a shifter operand'#000+
+  '07100_E_Address of packed component is not at a byte boundary'#000+
   '07101_W_No size specified and unable to determine the size of the oper'+
   'ands, using BYTE as default'#000+
-  '07102_W_Use of +offset(%ebp) for parameters invalid here'#000+
-  '07103_W_Use of +offset(%ebp) is not compatible with',' regcall conventi'+
-  'on'#000+
+  '07102_W_Use of +offset(%ebp',') for parameters invalid here'#000+
+  '07103_W_Use of +offset(%ebp) is not compatible with regcall convention'+
+  #000+
   '07104_W_Use of -offset(%ebp) is not recommended for local variable acc'+
   'ess'#000+
-  '07105_W_Use of -offset(%esp), access may cause a crash or value may be'+
-  ' lost'#000+
-  '07106_E_VMTOffset must be used in combination with a virtual method, a',
+  '07105_W_Use of -offset(%esp), access may cause a crash or value m','ay '+
+  'be lost'#000+
+  '07106_E_VMTOffset must be used in combination with a virtual method, a'+
   'nd "$1" is not virtual'#000+
   '07107_E_Generating PIC, but reference is not PIC-safe'#000+
   '07108_E_All registers in a register set must be of the same kind and w'+
   'idth'#000+
-  '07109_E_A register set cannot be empty'#000+
-  '07110_W_@GOTPCREL is useless and potentially dang','ereous for local sy'+
-  'mbols'#000+
+  '07109_E','_A register set cannot be empty'#000+
+  '07110_W_@GOTPCREL is useless and potentially dangereous for local symb'+
+  'ols'#000+
   '08000_F_Too many assembler files'#000+
   '08001_F_Selected assembler output not supported'#000+
   '08002_F_Comp not supported'#000+
-  '08003_F_Direct not support for binary writers'#000+
+  '08003_F_Direct not support',' for binary writers'#000+
   '08004_E_Allocating of data is only allowed in bss section'#000+
-  '080','05_F_No binary writer selected'#000+
+  '08005_F_No binary writer selected'#000+
   '08006_E_Asm: Opcode $1 not in table'#000+
   '08007_E_Asm: $1 invalid combination of opcode and operands'#000+
-  '08008_E_Asm: 16 Bit references not supported'#000+
+  '08008_E_Asm: 16 Bit references no','t supported'#000+
   '08009_E_Asm: Invalid effective address'#000+
-  '08010_E_Asm: Immediate or refe','rence expected'#000+
+  '08010_E_Asm: Immediate or reference expected'#000+
   '08011_E_Asm: $1 value exceeds bounds $2'#000+
   '08012_E_Asm: Short jump is out of range $1'#000+
   '08013_E_Asm: Undefined label $1'#000+
-  '08014_E_Asm: Comp type not supported for this target'#000+
-  '08015_E_Asm: Extended type not supported for this target'#000,
+  '08014_E_Asm: Comp type not su','pported for this target'#000+
+  '08015_E_Asm: Extended type not supported for this target'#000+
   '08016_E_Asm: Duplicate label $1'#000+
   '08017_E_Asm: Redefined label $1'#000+
   '08018_E_Asm: First defined here'#000+
   '08019_E_Asm: Invalid register $1'#000+
-  '08020_E_Asm: 16 or 32 Bit references not supported'#000+
+  '08020_E_Asm: 16 or 32 Bit refe','rences not supported'#000+
   '08021_E_Asm: 64 Bit operands not supported'#000+
-  '09000_W_Source op','erating system redefined'#000+
+  '09000_W_Source operating system redefined'#000+
   '09001_I_Assembling (pipe) $1'#000+
   '09002_E_Can'#039't create assembler file: $1'#000+
   '09003_E_Can'#039't create object file: $1'#000+
-  '09004_E_Can'#039't create archive file: $1'#000+
+  '09004_E_Can'#039't create archive',' file: $1'#000+
   '09005_E_Assembler $1 not found, switching to external assembling'#000+
-  '09006_','T_Using assembler: $1'#000+
+  '09006_T_Using assembler: $1'#000+
   '09007_E_Error while assembling exitcode $1'#000+
   '09008_E_Can'#039't call the assembler, error $1 switching to external a'+
   'ssembling'#000+
-  '09009_I_Assembling $1'#000+
+  '09009_I_Assembling',' $1'#000+
   '09010_I_Assembling with smartlinking $1'#000+
-  '09011_W_Object $1 not found, Linking ','may fail !'#000+
+  '09011_W_Object $1 not found, Linking may fail !'#000+
   '09012_W_Library $1 not found, Linking may fail !'#000+
   '09013_E_Error while linking'#000+
   '09014_E_Can'#039't call the linker, switching to external linking'#000+
-  '09015_I_Linking $1'#000+
+  '09015_I_Li','nking $1'#000+
   '09016_E_Util $1 not found, switching to external linking'#000+
-  '09017_T_Using u','til $1'#000+
+  '09017_T_Using util $1'#000+
   '09018_E_Creation of Executables not supported'#000+
   '09019_E_Creation of Dynamic/Shared Libraries not supported'#000+
   '09020_I_Closing script $1'#000+
-  '09021_E_resource compiler "$1" not found, switching to external mode'#000+
+  '09021_E_resource comp','iler "$1" not found, switching to external mode'+
+  #000+
   '09022_I_Compiling resource $1'#000+
-  '090','23_T_unit $1 can'#039't be statically linked, switching to smart l'+
-  'inking'#000+
+  '09023_T_unit $1 can'#039't be statically linked, switching to smart lin'+
+  'king'#000+
   '09024_T_unit $1 can'#039't be smart linked, switching to static linking'+
   #000+
-  '09025_T_unit $1 can'#039't be shared linked, switching to static linkin'+
-  'g'#000+
-  '09026_E_unit $1 can'#039't be smart or sta','tic linked'#000+
+  '09025_T_unit $1 can'#039't be',' shared linked, switching to static link'+
+  'ing'#000+
+  '09026_E_unit $1 can'#039't be smart or static linked'#000+
   '09027_E_unit $1 can'#039't be shared or static linked'#000+
   '09028_D_Calling resource compiler "$1" with "$2" as command line'#000+
-  '09029_E_Error while compiling resources'#000+
+  '09029_E_Error while compiling reso','urces'#000+
   '09030_E_Can'#039't call the resource compiler "$1", switching to extern'+
   'al mode'#000+
-  '0','9031_E_Can'#039't open resource file "$1"'#000+
+  '09031_E_Can'#039't open resource file "$1"'#000+
   '09032_E_Can'#039't write resource file "$1"'#000+
   '09128_F_Can'#039't post process executable $1'#000+
   '09129_F_Can'#039't open executable $1'#000+
-  '09130_X_Size of Code: $1 bytes'#000+
+  '09130_X_S','ize of Code: $1 bytes'#000+
   '09131_X_Size of initialized data: $1 bytes'#000+
-  '09132_X_Size of ','uninitialized data: $1 bytes'#000+
+  '09132_X_Size of uninitialized data: $1 bytes'#000+
   '09133_X_Stack space reserved: $1 bytes'#000+
   '09134_X_Stack space committed: $1 bytes'#000+
-  '09200_F_Executable image size is too big for $1 target.'#000+
+  '09200_F_Executable image size is too big for $1 tar','get.'#000+
   '09201_W_Object file "$1" contains 32-bit absolute relocation to symbol'+
-  ' "$2".',#000+
+  ' "$2".'#000+
   '10000_T_Unitsearch: $1'#000+
   '10001_T_PPU Loading $1'#000+
   '10002_U_PPU Name: $1'#000+
@@ -870,162 +873,162 @@
   '10004_U_PPU Crc: $1'#000+
   '10005_U_PPU Time: $1'#000+
   '10006_U_PPU File too short'#000+
-  '10007_U_PPU Invalid Header (no PPU at the begin)'#000+
+  '1','0007_U_PPU Invalid Header (no PPU at the begin)'#000+
   '10008_U_PPU Invalid Version $1'#000+
-  '10','009_U_PPU is compiled for another processor'#000+
+  '10009_U_PPU is compiled for another processor'#000+
   '10010_U_PPU is compiled for another target'#000+
   '10011_U_PPU Source: $1'#000+
   '10012_U_Writing $1'#000+
   '10013_F_Can'#039't Write PPU-File'#000+
-  '10014_F_Error reading PPU-File'#000+
+  '1','0014_F_Error reading PPU-File'#000+
   '10015_F_unexpected end of PPU-File'#000+
-  '10016_F_Invalid ','PPU-File entry: $1'#000+
+  '10016_F_Invalid PPU-File entry: $1'#000+
   '10017_F_PPU Dbx count problem'#000+
   '10018_E_Illegal unit name: $1'#000+
   '10019_F_Too much units'#000+
   '10020_F_Circular unit reference between $1 and $2'#000+
-  '10021_F_Can'#039't compile unit $1, no sources available'#000+
-  '10022_F_Can'#039't find unit $1 used by $','2'#000+
+  '10021_F','_Can'#039't compile unit $1, no sources available'#000+
+  '10022_F_Can'#039't find unit $1 used by $2'#000+
   '10023_W_Unit $1 was not found but $2 exists'#000+
   '10024_F_Unit $1 searched but $2 found'#000+
   '10025_W_Compiling the system unit requires the -Us switch'#000+
-  '10026_F_There were $1 errors compiling module, stopping'#000+
+  '10026_F_There wer','e $1 errors compiling module, stopping'#000+
   '10027_U_Load from $1 ($2) unit $3'#000+
-  '10028_U_','Recompiling $1, checksum changed for $2'#000+
+  '10028_U_Recompiling $1, checksum changed for $2'#000+
   '10029_U_Recompiling $1, source found only'#000+
   '10030_U_Recompiling unit, static lib is older than ppufile'#000+
-  '10031_U_Recompiling unit, shared lib is older than ppufile'#000+
-  '10032_U_Recompiling unit, obj and asm ar','e older than ppufile'#000+
+  '10031_U_Recompilin','g unit, shared lib is older than ppufile'#000+
+  '10032_U_Recompiling unit, obj and asm are older than ppufile'#000+
   '10033_U_Recompiling unit, obj is older than asm'#000+
   '10034_U_Parsing interface of $1'#000+
   '10035_U_Parsing implementation of $1'#000+
-  '10036_U_Second load for unit $1'#000+
+  '10036_U_Second load f','or unit $1'#000+
   '10037_U_PPU Check file $1 time $2'#000+
-  '10040_W_Can'#039't recompile unit $1, but',' found modifed include files'+
-  #000+
+  '10040_W_Can'#039't recompile unit $1, but found modifed include files'#000+
   '10041_U_File $1 is newer than the one used for creating PPU file $2'#000+
-  '10042_U_Trying to use a unit which was compiled with a different FPU m'+
-  'ode'#000+
+  '10042_U_Trying to use a unit which was compiled with a differe','nt FPU'+
+  ' mode'#000+
   '10043_U_Loading interface units from $1'#000+
-  '10044_U_Loading implementatio','n units from $1'#000+
+  '10044_U_Loading implementation units from $1'#000+
   '10045_U_Interface CRC changed for unit $1'#000+
   '10046_U_Implementation CRC changed for unit $1'#000+
   '10047_U_Finished compiling unit $1'#000+
-  '10048_U_Adding dependency: $1 depends on $2'#000+
+  '10048_U_Adding depe','ndency: $1 depends on $2'#000+
   '10049_U_No reload, is caller: $1'#000+
-  '10050_U_No reload, alre','ady in second compile: $1'#000+
+  '10050_U_No reload, already in second compile: $1'#000+
   '10051_U_Flag for reload: $1'#000+
   '10052_U_Forced reloading'#000+
   '10053_U_Previous state of $1: $2'#000+
-  '10054_U_Already compiling $1, setting second compile'#000+
+  '10054_U_Already compiling $1, setting second co','mpile'#000+
   '10055_U_Loading unit $1'#000+
   '10056_U_Finished loading unit $1'#000+
-  '10057_U_Registerin','g new unit $1'#000+
+  '10057_U_Registering new unit $1'#000+
   '10058_U_Re-resolving unit $1'#000+
   '10059_U_Skipping re-resolving unit $1, still loading used units'#000+
   '10060_U_Unloading resource unit $1 (not needed)'#000+
-  '10061_E_Unit $1 was compiled using a different whole program optimizat'+
-  'ion feedback in','put ($2, $3); recompile it without wpo or use the sam'+
+  '1006','1_E_Unit $1 was compiled using a different whole program optimiz'+
+  'ation feedback input ($2, $3); recompile it without wpo or use the sam'+
   'e wpo feedback input file for this compilation invocation'#000+
-  '10062_U_Indirect interface (objects/classes) CRC changed for unit $1'#000+
+  '10062_U_Indirect interface (objects/classes) CRC',' changed for unit $1'+
+  #000+
   '11000_O_$1 [options] <inputfile> [options]'#000+
-  '11001_W_Only one ','source file supported, changing source file to comp'+
-  'ile from "$1" into "$2"'#000+
+  '11001_W_Only one source file supported, changing source file to compil'+
+  'e from "$1" into "$2"'#000+
   '11002_W_DEF file can be created only for OS/2'#000+
-  '11003_E_nested response files are not supported'#000+
+  '11003_E_nested response files are not ','supported'#000+
   '11004_F_No source file name in command line'#000+
-  '11005_N_No option inside $1',' config file'#000+
+  '11005_N_No option inside $1 config file'#000+
   '11006_E_Illegal parameter: $1'#000+
   '11007_H_-? writes help pages'#000+
   '11008_F_Too many config files nested'#000+
   '11009_F_Unable to open file $1'#000+
-  '11010_D_Reading further options from $1'#000+
+  '11010_D_Reading fur','ther options from $1'#000+
   '11011_W_Target is already set to: $1'#000+
-  '11012_W_Shared libs not',' supported on DOS platform, reverting to stat'+
-  'ic'#000+
+  '11012_W_Shared libs not supported on DOS platform, reverting to static'+
+  #000+
   '11013_F_In options file $1 at line $2 too many \var{\#IF(N)DEFs} encou'+
   'ntered'#000+
-  '11014_F_In options file $1 at line $2 unexpected \var{\#ENDIFs} encoun'+
-  'tered'#000+
-  '11015_F_Open conditional at the end of ','the options file'#000+
+  '11014_F_In options file $1 at line',' $2 unexpected \var{\#ENDIFs} enco'+
+  'untered'#000+
+  '11015_F_Open conditional at the end of the options file'#000+
   '11016_W_Debug information generation is not supported by this executab'+
   'le'#000+
   '11017_H_Try recompiling with -dGDB'#000+
-  '11018_W_You are using the obsolete switch $1'#000+
+  '11018_W_You are using the obsolete',' switch $1'#000+
   '11019_W_You are using the obsolete switch $1, please use $2'#000+
-  '11020_N_Sw','itching assembler to default source writing assembler'#000+
+  '11020_N_Switching assembler to default source writing assembler'#000+
   '11021_W_Assembler output selected "$1" is not compatible with "$2"'#000+
   '11022_W_"$1" assembler use forced'#000+
-  '11026_T_Reading options from file $1'#000+
+  '1102','6_T_Reading options from file $1'#000+
   '11027_T_Reading options from environment $1'#000+
-  '1102','8_D_Handling option "$1"'#000+
+  '11028_D_Handling option "$1"'#000+
   '11029_O_*** press enter ***'#000+
   '11030_H_Start of reading config file $1'#000+
   '11031_H_End of reading config file $1'#000+
-  '11032_D_interpreting option "$1"'#000+
+  '11032_D_interpreting option ','"$1"'#000+
   '11036_D_interpreting firstpass option "$1"'#000+
-  '11033_D_interpreting file option ','"$1"'#000+
+  '11033_D_interpreting file option "$1"'#000+
   '11034_D_Reading config file "$1"'#000+
   '11035_D_found source file name "$1"'#000+
   '11039_E_Unknown code page'#000+
   '11040_F_Config file $1 is a directory'#000+
-  '11041_W_Assembler output selected "$1" cannot generate debug info, deb'+
-  'ugging disabled'#000+
-  '11042_W_Use of p','pc386.cfg is deprecated, please use fpc.cfg instead'#000+
+  '11041_W_Assembler out','put selected "$1" cannot generate debug info, d'+
+  'ebugging disabled'#000+
+  '11042_W_Use of ppc386.cfg is deprecated, please use fpc.cfg instead'#000+
   '11043_F_In options file $1 at line $2 \var{\#ELSE} directive without \'+
   'var{\#IF(N)DEF} found'#000+
-  '11044_F_Option "$1" is not, or not yet, supported on the current targe'+
-  't platform'#000+
-  '11045_F_The fea','ture "$1" is not, or not yet, supported on the select'+
-  'ed target platform'#000+
+  '11044_F_Option ','"$1" is not, or not yet, supported on the current tar'+
+  'get platform'#000+
+  '11045_F_The feature "$1" is not, or not yet, supported on the selected'+
+  ' target platform'#000+
   '11046_N_DWARF debug information cannot be used with smart linking on t'+
-  'his target, switching to static linking'#000+
-  '11047_W_Option "$1" is ignored for the current target plat','form.'#000+
+  'his target, switc','hing to static linking'#000+
+  '11047_W_Option "$1" is ignored for the current target platform.'#000+
   '11048_W_Disabling external debug information because it is unsupported'+
   ' for the selected target/debug format combination.'#000+
-  '12000_F_Cannot open whole program optimization feedback file "$1"'#000+
-  '12001_D_Processing whole program optimization i','nformation in wpo fee'+
-  'dback file "$1"'#000+
+  '12000_F_Cannot open whole progra','m optimization feedback file "$1"'#000+
+  '12001_D_Processing whole program optimization information in wpo feedb'+
+  'ack file "$1"'#000+
   '12002_D_Finished processing the whole program optimization information'+
   ' in wpo feedback file "$1"'#000+
-  '12003_E_Expected section header, but got "$2" at line $1 of wpo feedba'+
-  'ck file'#000+
-  '12004_W_No handler registere','d for whole program optimization section'+
-  ' "$2" at line $1 of wpo feedback file, ignoring'#000+
+  '12003_E_Expected section ','header, but got "$2" at line $1 of wpo feed'+
+  'back file'#000+
+  '12004_W_No handler registered for whole program optimization section "'+
+  '$2" at line $1 of wpo feedback file, ignoring'#000+
   '12005_D_Found whole program optimization section "$1" with information'+
-  ' about "$2"'#000+
-  '12006_F_The selected whole program optimizations require a previously ',
+  ' ','about "$2"'#000+
+  '12006_F_The selected whole program optimizations require a previously '+
   'generated feedback file (use -Fw to specify)'#000+
   '12007_E_No collected information necessary to perform "$1" whole progr'+
   'am optimization found'#000+
-  '12008_F_Specify a whole program optimization feedback file to store th'+
-  'e generated info in (using -FW)'#000+
-  '1','2009_E_Not generating any whole program optimization information, y'+
-  'et a feedback file was specified (using -FW)'#000+
-  '12010_E_Not performing any whole program optimizations, yet an input f'+
-  'eedback file was specified (using -Fw)'#000+
-  '12011_D_Skipping wh','ole program optimization section "$1", because no'+
-  't needed by the requested optimizations'#000+
-  '12012_W_Overriding previously read information for "$1" from feedback '+
+  '12008_F_Specify a whol','e program optimization feedback file to store '+
+  'the generated info in (using -FW)'#000+
+  '12009_E_Not generating any whole program optimization information, yet'+
+  ' a feedback file was specified (using -FW)'#000+
+  '12010_E_Not performing any whole program optimi','zations, yet an input'+
+  ' feedback file was specified (using -Fw)'#000+
+  '12011_D_Skipping whole program optimization section "$1", because not '+
+  'needed by the requested optimizations'#000+
+  '12012_W_Overriding previously read information for "$1" from feedback ',
   'input file using information in section "$2"'#000+
-  '12013_E_Cannot extract symbol livene','ss information from program when'+
-  ' stripping symbols, use -Xs-'#000+
+  '12013_E_Cannot extract symbol liveness information from program when s'+
+  'tripping symbols, use -Xs-'#000+
   '12014_E_Cannot extract symbol liveness information from program when w'+
   'hen not linking'#000+
-  '12015_F_Cannot find "$1" or "$2" to extract symbol liveness informatio'+
-  'n from linked program'#000+
-  '1','2016_E_Error during reading symbol liveness information produced by'+
-  ' "$1"'#000+
+  '12015_F_Cann','ot find "$1" or "$2" to extract symbol liveness informat'+
+  'ion from linked program'#000+
+  '12016_E_Error during reading symbol liveness information produced by "'+
+  '$1"'#000+
   '12017_F_Error executing "$1" (exitcode: $2) to extract symbol informat'+
-  'ion from linked program'#000+
+  'ion from linked ','program'#000+
   '12018_E_Collection of symbol liveness information can only help when u'+
-  'sin','g smart linking, use -CX -XX'#000+
+  'sing smart linking, use -CX -XX'#000+
   '12019_E_Cannot create specified whole program optimisation feedback fi'+
   'le "$1"'#000+
-  '11023_Free Pascal Compiler version $FPCFULLVERSION [$FPCDATE] for $FPC'+
-  'CPU'#010+
+  '11023_Free Pascal Compiler version $FPCFULLVERSION [','$FPCDATE] for $F'+
+  'PCCPU'#010+
   'Copyright (c) 1993-2010 by Florian Klaempfl'#000+
-  '11024_Free Pasc','al Compiler version $FPCVERSION'#010+
+  '11024_Free Pascal Compiler version $FPCVERSION'#010+
   #010+
   'Compiler Date      : $FPCDATE'#010+
   'Compiler CPU Target: $FPCCPU'#010+
@@ -1034,12 +1037,12 @@
   '  $OSTARGETS'#010+
   #010+
   'Supported CPU instruction sets:'#010+
-  '  $INSTRUCTIONSETS'#010+
+  ' ',' $INSTRUCTIONSETS'#010+
   #010+
   'Supported FPU instruction sets:'#010+
   '  $FPUINSTRUCTIONSETS'#010+
   #010+
-  'Support','ed ABI targets:'#010+
+  'Supported ABI targets:'#010+
   '  $ABITARGETS'#010+
   #010+
   'Supported Optimizations:'#010+
@@ -1049,309 +1052,308 @@
   '  All'#010+
   '  $WPOPTIMIZATIONS'#010+
   #010+
-  'Supported Microcontroller types:'#010+
+  'Supported Microcontr','oller types:'#010+
   '  $CONTROLLERTYPES'#010+
   #010+
-  'This program comes under the GNU General Public ','Licence'#010+
+  'This program comes under the GNU General Public Licence'#010+
   'For more information read COPYING.FPC'#010+
   #010+
   'Report bugs, suggestions, etc. to:'#010+
   '                 http://bugs.freepascal.org'#010+
   'or'#010+
-  '                 bugs@freepascal.org'#000+
+  '                 bugs@freepasc','al.org'#000+
   '11025_**0*_Put + after a boolean switch option to enable it, - to disa'+
-  'ble ','it'#010+
+  'ble it'#010+
   '**1a_The compiler doesn'#039't delete the generated assembler file'#010+
   '**2al_List sourcecode lines in assembler file'#010+
   '**2an_List node info in assembler file'#010+
-  '*L2ap_Use pipes instead of creating temporary assembler files'#010+
-  '**2ar_List register allocati','on/release info in assembler file'#010+
+  '*L2ap_Use',' pipes instead of creating temporary assembler files'#010+
+  '**2ar_List register allocation/release info in assembler file'#010+
   '**2at_List temp allocation/release info in assembler file'#010+
   '**1A<x>_Output format:'#010+
   '**2Adefault_Use default assembler'#010+
-  '3*2Aas_Assemble using GNU AS'#010+
-  '3*2Amacho_Mach-O (Darwin, Intel 32 bit) using internal writer'#010,
+  '3*2Aas_Ass','emble using GNU AS'#010+
+  '3*2Amacho_Mach-O (Darwin, Intel 32 bit) using internal writer'#010+
   '3*2Anasmcoff_COFF (Go32v2) file using Nasm'#010+
   '3*2Anasmelf_ELF32 (Linux) file using Nasm'#010+
   '3*2Anasmwin32_Win32 object file using Nasm'#010+
-  '3*2Anasmwdosx_Win32/WDOSX object file using Nasm'#010+
+  '3*2Anasmwdosx_Win32/WDOSX objec','t file using Nasm'#010+
   '3*2Awasm_Obj file using Wasm (Watcom)'#010+
-  '3*2Anasmobj_Obj file usin','g Nasm'#010+
+  '3*2Anasmobj_Obj file using Nasm'#010+
   '3*2Amasm_Obj file using Masm (Microsoft)'#010+
   '3*2Atasm_Obj file using Tasm (Borland)'#010+
   '3*2Aelf_ELF (Linux) using internal writer'#010+
-  '3*2Acoff_COFF (Go32v2) using internal writer'#010+
+  '3*2Acoff_COFF (Go32v2) using i','nternal writer'#010+
   '3*2Apecoff_PE-COFF (Win32) using internal writer'#010+
-  '4*2Aas_Assemble u','sing GNU AS'#010+
+  '4*2Aas_Assemble using GNU AS'#010+
   '6*2Aas_Unix o-file using GNU AS'#010+
   '6*2Agas_GNU Motorola assembler'#010+
   '6*2Amit_MIT Syntax (old GAS)'#010+
   '6*2Amot_Standard Motorola assembler'#010+
-  'A*2Aas_Assemble using GNU AS'#010+
+  'A*2Aas_Assemble usi','ng GNU AS'#010+
   'P*2Aas_Assemble using GNU AS'#010+
   'S*2Aas_Assemble using GNU AS'#010+
-  '**1b_Generate',' browser info'#010+
+  '**1b_Generate browser info'#010+
   '**2bl_Generate local symbol info'#010+
   '**1B_Build all modules'#010+
   '**1C<x>_Code generation options:'#010+
   '**2C3<x>_Turn on ieee error checking for constants'#010+
-  '**2Ca<x>_Select ABI, see fpc -i for possible values'#010+
+  '**2Ca','<x>_Select ABI, see fpc -i for possible values'#010+
   '**2Cb_Generate big-endian code'#010+
-  '**2','Cc<x>_Set default calling convention to <x>'#010+
+  '**2Cc<x>_Set default calling convention to <x>'#010+
   '**2CD_Create also dynamic library (not supported)'#010+
   '**2Ce_Compilation with emulated floating point opcodes'#010+
-  '**2Cf<x>_Select fpu instruction set to use, see fpc -i for possible va'+
-  'lues'#010+
-  '**2CF<x>_Minimal',' floating point constant precision (default, 32, 64)'+
-  #010+
+  '**2Cf<x>_S','elect fpu instruction set to use, see fpc -i for possible '+
+  'values'#010+
+  '**2CF<x>_Minimal floating point constant precision (default, 32, 64)'#010+
   '**2Cg_Generate PIC code'#010+
   '**2Ch<n>_<n> bytes heap (between 1023 and 67107840)'#010+
   '**2Ci_IO-checking'#010+
-  '**2Cn_Omit linking stage'#010+
+  '**2Cn_Omit l','inking stage'#010+
   '**2Co_Check overflow of integer operations'#010+
-  '**2CO_Check for possible ','overflow of integer operations'#010+
+  '**2CO_Check for possible overflow of integer operations'#010+
   '**2Cp<x>_Select instruction set, see fpc -i for possible values'#010+
   '**2CP<x>=<y>_ packing settings'#010+
-  '**3CPPACKSET=<y>_ <y> set allocation: 0, 1 or DEFAULT or NORMAL, 2, 4 '+
-  'and 8'#010+
+  '**3CPPACKSET=<y>_ <y> set allocat','ion: 0, 1 or DEFAULT or NORMAL, 2, '+
+  '4 and 8'#010+
   '**2Cr_Range checking'#010+
-  '**2CR_Verify obje','ct method call validity'#010+
+  '**2CR_Verify object method call validity'#010+
   '**2Cs<n>_Set stack checking size to <n>'#010+
   '**2Ct_Stack checking (for testing only, see manual)'#010+
   '**2CX_Create also smartlinked library'#010+
-  '**1d<x>_Defines the symbol <x>'#010+
+  '**1d<','x>_Defines the symbol <x>'#010+
   '**1D_Generate a DEF file'#010+
-  '**2Dd<x>_Set description to <x','>'#010+
+  '**2Dd<x>_Set description to <x>'#010+
   '**2Dv<x>_Set DLL version to <x>'#010+
   '*O2Dw_PM application'#010+
   '**1e<x>_Set path to executable'#010+
   '**1E_Same as -Cn'#010+
   '**1fPIC_Same as -Cg'#010+
   '**1F<x>_Set file names and paths:'#010+
-  '**2Fa<x>[,y]_(for a program) load units <x> and [y] before uses is par'+
-  'sed'#010+
-  '**2Fc<x>_','Set input codepage to <x>'#010+
+  '**','2Fa<x>[,y]_(for a program) load units <x> and [y] before uses is p'+
+  'arsed'#010+
+  '**2Fc<x>_Set input codepage to <x>'#010+
   '**2FC<x>_Set RC compiler binary name to <x>'#010+
   '**2Fd_Disable the compiler'#039's internal directory cache'#010+
-  '**2FD<x>_Set the directory where to search for compiler utilities'#010+
+  '**2FD<x>_Set the directory where to',' search for compiler utilities'#010+
   '**2Fe<x>_Redirect error output to <x>'#010+
-  '**2Ff<x>_Add',' <x> to framework path (Darwin only)'#010+
+  '**2Ff<x>_Add <x> to framework path (Darwin only)'#010+
   '**2FE<x>_Set exe/unit output path to <x>'#010+
   '**2Fi<x>_Add <x> to include path'#010+
   '**2Fl<x>_Add <x> to library path'#010+
-  '**2FL<x>_Use <x> as dynamic linker'#010+
-  '**2Fm<x>_Load unicode conversion table from <x>.txt in the co','mpiler '+
-  'dir'#010+
+  '**2FL<x>_Use <x','> as dynamic linker'#010+
+  '**2Fm<x>_Load unicode conversion table from <x>.txt in the compiler di'+
+  'r'#010+
   '**2Fo<x>_Add <x> to object path'#010+
   '**2Fr<x>_Load error message file <x>'#010+
   '**2FR<x>_Set resource (.res) linker to <x>'#010+
   '**2Fu<x>_Add <x> to unit path'#010+
-  '**2FU<x>_Set unit output path to <x>, overrides -FE'#010+
-  '**2FW<x>_Store generated whole-prog','ram optimization feedback in <x>'#010+
+  '**2FU<','x>_Set unit output path to <x>, overrides -FE'#010+
+  '**2FW<x>_Store generated whole-program optimization feedback in <x>'#010+
   '**2Fw<x>_Load previously stored whole-program optimization feedback fr'+
   'om <x>'#010+
-  '*g1g_Generate debug information (default format for target)'#010+
+  '*g1g_Generate debug information (default format f','or target)'#010+
   '*g2gc_Generate checks for pointers'#010+
-  '*g2gh_Use heaptrace unit (for memor','y leak/corruption debugging)'#010+
+  '*g2gh_Use heaptrace unit (for memory leak/corruption debugging)'#010+
   '*g2gl_Use line info unit (show more info with backtraces)'#010+
   '*g2go<x>_Set debug information options'#010+
-  '*g3godwarfsets_ Enable DWARF '#039'set'#039' type debug information (bre'+
+  '*g3godwarfsets_ Enable DWARF '#039'set',#039' type debug information (bre'+
   'aks gdb < 6.5)'#010+
-  '*g3gostabsabsincludes_ Store absolute','/full include file paths in Sta'+
-  'bs'#010+
+  '*g3gostabsabsincludes_ Store absolute/full include file paths in Stabs'+
+  #010+
   '*g3godwarfmethodclassprefix_ Prefix method names in DWARF with class n'+
   'ame'#010+
   '*g2gp_Preserve case in stabs symbol names'#010+
-  '*g2gs_Generate Stabs debug information'#010+
-  '*g2gt_Trash local variables (to detect uninitialize','d uses)'#010+
+  '*g2gs_Gen','erate Stabs debug information'#010+
+  '*g2gt_Trash local variables (to detect uninitialized uses)'#010+
   '*g2gv_Generates programs traceable with Valgrind'#010+
   '*g2gw_Generate DWARFv2 debug information (same as -gw2)'#010+
   '*g2gw2_Generate DWARFv2 debug information'#010+
-  '*g2gw3_Generate DWARFv3 debug information'#010+
-  '*g2gw4_Generate DWARFv4 debug information (','experimental)'#010+
+  '*g2g','w3_Generate DWARFv3 debug information'#010+
+  '*g2gw4_Generate DWARFv4 debug information (experimental)'#010+
   '**1i_Information'#010+
   '**2iD_Return compiler date'#010+
   '**2iV_Return short compiler version'#010+
   '**2iW_Return full compiler version'#010+
   '**2iSO_Return compiler OS'#010+
-  '**2iSP_Return compiler host processor'#010+
+  '**2i','SP_Return compiler host processor'#010+
   '**2iTO_Return target OS'#010+
-  '**2iTP_Return target pr','ocessor'#010+
+  '**2iTP_Return target processor'#010+
   '**1I<x>_Add <x> to include path'#010+
   '**1k<x>_Pass <x> to the linker'#010+
   '**1l_Write logo'#010+
   '**1M<x>_Set language mode to <x>'#010+
   '**2Mfpc_Free Pascal dialect (default)'#010+
-  '**2Mobjfpc_FPC mode with Object Pascal support'#010+
-  '**2Mdelphi_Delphi 7 compatibility m','ode'#010+
+  '*','*2Mobjfpc_FPC mode with Object Pascal support'#010+
+  '**2Mdelphi_Delphi 7 compatibility mode'#010+
   '**2Mtp_TP/BP 7.0 compatibility mode'#010+
   '**2Mmacpas_Macintosh Pascal dialects compatibility mode'#010+
   '**1n_Do not read the default config files'#010+
-  '**1N<x>_Node tree optimizations'#010+
+  '**1N<x>_Node tree opt','imizations'#010+
   '**2Nu_Unroll loops'#010+
-  '**1o<x>_Change the name of the executable produced ','to <x>'#010+
+  '**1o<x>_Change the name of the executable produced to <x>'#010+
   '**1O<x>_Optimizations:'#010+
   '**2O-_Disable optimizations'#010+
   '**2O1_Level 1 optimizations (quick and debugger friendly)'#010+
-  '**2O2_Level 2 optimizations (-O1 + quick optimizations)'#010+
+  '**2O2_Level 2 optimizations (-O1 + quick op','timizations)'#010+
   '**2O3_Level 3 optimizations (-O2 + slow optimizations)'#010+
-  '**2Oa<x>=<y>_','Set alignment'#010+
+  '**2Oa<x>=<y>_Set alignment'#010+
   '**2Oo[NO]<x>_Enable or disable optimizations, see fpc -i for possible '+
   'values'#010+
-  '**2Op<x>_Set target cpu for optimizing, see fpc -i for possible values'+
-  #010+
+  '**2Op<x>_Set target cpu for optimizing, see fpc -i for possible valu','e'+
+  's'#010+
   '**2OW<x>_Generate whole-program optimization feedback for optimization'+
-  ' <x>, se','e fpc -i for possible values'#010+
+  ' <x>, see fpc -i for possible values'#010+
   '**2Ow<x>_Perform whole-program optimization <x>, see fpc -i for possib'+
   'le values'#010+
   '**2Os_Optimize for size rather than speed'#010+
-  '**1pg_Generate profile code for gprof (defines FPC_PROFILE)'#010+
-  '**1R<x>_Assembler reading sty','le:'#010+
+  '**1pg_Ge','nerate profile code for gprof (defines FPC_PROFILE)'#010+
+  '**1R<x>_Assembler reading style:'#010+
   '**2Rdefault_Use default assembler for target'#010+
   '3*2Ratt_Read AT&T style assembler'#010+
   '3*2Rintel_Read Intel style assembler'#010+
   '6*2RMOT_Read motorola style assembler'#010+
-  '**1S<x>_Syntax options:'#010+
+  '*','*1S<x>_Syntax options:'#010+
   '**2S2_Same as -Mobjfpc'#010+
-  '**2Sc_Support operators like C (*=,','+=,/= and -=)'#010+
+  '**2Sc_Support operators like C (*=,+=,/= and -=)'#010+
   '**2Sa_Turn on assertions'#010+
   '**2Sd_Same as -Mdelphi'#010+
   '**2Se<x>_Error options. <x> is a combination of the following:'#010+
-  '**3*_<n> : Compiler halts after the <n> errors (default is 1)'#010+
+  '**3*_<n> : Compiler halts after th','e <n> errors (default is 1)'#010+
   '**3*_w : Compiler also halts after warnings'#010+
-  '**3*_n : ','Compiler also halts after notes'#010+
+  '**3*_n : Compiler also halts after notes'#010+
   '**3*_h : Compiler also halts after hints'#010+
   '**2Sg_Enable LABEL and GOTO (default in -Mtp and -Mdelphi)'#010+
-  '**2Sh_Use ansistrings by default instead of shortstrings'#010+
-  '**2Si_Turn on inlining of procedures/functions decl','ared as "inline"'#010+
+  '**2Sh_Use ansistrings by de','fault instead of shortstrings'#010+
+  '**2Si_Turn on inlining of procedures/functions declared as "inline"'#010+
   '**2Sk_Load fpcylix unit'#010+
   '**2SI<x>_Set interface style to <x>'#010+
   '**3SIcom_COM compatible interface (default)'#010+
-  '**3SIcorba_CORBA compatible interface'#010+
+  '**3SIcorba_CORBA compatible interface'#010,
   '**2Sm_Support macros like C (global)'#010+
   '**2So_Same as -Mtp'#010+
-  '**2Ss_Constructor name mu','st be init (destructor must be done)'#010+
+  '**2Ss_Constructor name must be init (destructor must be done)'#010+
   '**2Sx_Enable exception keywords (default in Delphi/ObjFPC modes)'#010+
   '**1s_Do not call assembler and linker'#010+
-  '**2sh_Generate script to link on host'#010+
+  '**2sh_Generate scri','pt to link on host'#010+
   '**2st_Generate script to link on target'#010+
-  '**2sr_Skip register al','location phase (use with -alr)'#010+
+  '**2sr_Skip register allocation phase (use with -alr)'#010+
   '**1T<x>_Target operating system:'#010+
   '3*2Tdarwin_Darwin/Mac OS X'#010+
   '3*2Temx_OS/2 via EMX (including EMX/RSX extender)'#010+
-  '3*2Tfreebsd_FreeBSD'#010+
+  '3*2Tfreebsd_FreeBS','D'#010+
   '3*2Tgo32v2_Version 2 of DJ Delorie DOS extender'#010+
-  '3*2Tiphonesim_ iPhoneSimulator ','from iOS SDK 3.2+ (older versions: -T'+
-  'darwin)'#010+
+  '3*2Tiphonesim_ iPhoneSimulator from iOS SDK 3.2+ (older versions: -Tda'+
+  'rwin)'#010+
   '3*2Tlinux_Linux'#010+
   '3*2Tnetbsd_NetBSD'#010+
   '3*2Tnetware_Novell Netware Module (clib)'#010+
-  '3*2Tnetwlibc_Novell Netware Module (libc)'#010+
+  '3*2Tnetwlibc_Novell Netware Module (lib','c)'#010+
   '3*2Topenbsd_OpenBSD'#010+
   '3*2Tos2_OS/2 / eComStation'#010+
   '3*2Tsunos_SunOS/Solaris'#010+
-  '3*2Tsym','bian_Symbian OS'#010+
+  '3*2Tsymbian_Symbian OS'#010+
   '3*2Tsolaris_Solaris'#010+
   '3*2Twatcom_Watcom compatible DOS extender'#010+
   '3*2Twdosx_WDOSX DOS extender'#010+
   '3*2Twin32_Windows 32 Bit'#010+
   '3*2Twince_Windows CE'#010+
-  '4*2Tdarwin_Darwin/Mac OS X'#010+
+  '4*2Tda','rwin_Darwin/Mac OS X'#010+
   '4*2Tlinux_Linux'#010+
   '4*2Twin64_Win64 (64 bit Windows systems)'#010+
-  '6*2','Tamiga_Commodore Amiga'#010+
+  '6*2Tamiga_Commodore Amiga'#010+
   '6*2Tatari_Atari ST/STe/TT'#010+
   '6*2Tlinux_Linux'#010+
   '6*2Tpalmos_PalmOS'#010+
   'A*2Tdarwin_Darwin/iPhoneOS/iOS'#010+
   'A*2Tlinux_Linux'#010+
   'A*2Twince_Windows CE'#010+
-  'P*2Tamiga_AmigaOS'#010+
+  'P*2Tamig','a_AmigaOS'#010+
   'P*2Tdarwin_Darwin/Mac OS X'#010+
   'P*2Tlinux_Linux'#010+
   'P*2Tmacos_Mac OS (classic)'#010+
-  'P','*2Tmorphos_MorphOS'#010+
+  'P*2Tmorphos_MorphOS'#010+
   'S*2Tsolaris_Solaris'#010+
   'S*2Tlinux_Linux'#010+
   '**1u<x>_Undefines the symbol <x>'#010+
   '**1U_Unit options:'#010+
-  '**2Un_Do not check where the unit name matches the file name'#010+
+  '**2Un_Do not check where the unit name matches the f','ile name'#010+
   '**2Ur_Generate release unit files (never automatically recompiled)'#010+
-  '**2Us','_Compile a system unit'#010+
+  '**2Us_Compile a system unit'#010+
   '**1v<x>_Be verbose. <x> is a combination of the following letters:'#010+
-  '**2*_e : Show errors (default)       0 : Show nothing (except errors)'#010+
+  '**2*_e : Show errors (default)       0 : Show nothing (except errors)',
+  #010+
   '**2*_w : Show warnings               u : Show unit info'#010+
-  '**2*_n : Show notes     ','             t : Show tried/used files'#010+
+  '**2*_n : Show notes                  t : Show tried/used files'#010+
   '**2*_h : Show hints                  c : Show conditionals'#010+
   '**2*_i : Show general info           d : Show debug info'#010+
-  '**2*_l : Show linenumbers            r : Rhide/GCC compatibility mode'#010+
-  '**2*_s : Show t','ime stamps            q : Show message numbers'#010+
+  '**2*','_l : Show linenumbers            r : Rhide/GCC compatibility mod'+
+  'e'#010+
+  '**2*_s : Show time stamps            q : Show message numbers'#010+
   '**2*_a : Show everything             x : Executable info (Win32 only)'#010+
-  '**2*_b : Write file names messages   p : Write tree.log with parse tre'+
-  'e'#010+
-  '**2*_    with full path              v : Write fpcd','ebug.txt with'#010+
+  '**2*_b : Write file names messages   p : W','rite tree.log with parse t'+
+  'ree'#010+
+  '**2*_    with full path              v : Write fpcdebug.txt with'#010+
   '**2*_                                    lots of debugging info'#010+
   '**2*_m<x>,<y> : Don'#039't show messages numbered <x> and <y>'#010+
-  '3*1W<x>_Target-specific options (targets)'#010+
+  '3*1W<x>_Target-specific ','options (targets)'#010+
   'A*1W<x>_Target-specific options (targets)'#010+
-  'P*1W<x>_Target-specif','ic options (targets)'#010+
+  'P*1W<x>_Target-specific options (targets)'#010+
   'p*1W<x>_Target-specific options (targets)'#010+
   '3*2Wb_Create a bundle instead of a library (Darwin)'#010+
-  'P*2Wb_Create a bundle instead of a library (Darwin)'#010+
+  'P*2Wb_Create a bundle instead of a library (','Darwin)'#010+
   'p*2Wb_Create a bundle instead of a library (Darwin)'#010+
-  '3*2WB_Create a reloca','table image (Windows)'#010+
+  '3*2WB_Create a relocatable image (Windows)'#010+
   'A*2WB_Create a relocatable image (Windows, Symbian)'#010+
   '3*2WC_Specify console type application (EMX, OS/2, Windows)'#010+
-  'A*2WC_Specify console type application (Windows)'#010+
+  'A*2WC_Specify console typ','e application (Windows)'#010+
   'P*2WC_Specify console type application (Classic Mac OS)'#010+
-  '3','*2WD_Use DEFFILE to export functions of DLL or EXE (Windows)'#010+
+  '3*2WD_Use DEFFILE to export functions of DLL or EXE (Windows)'#010+
   'A*2WD_Use DEFFILE to export functions of DLL or EXE (Windows)'#010+
-  '3*2We_Use external resources (Darwin)'#010+
+  '3*2We_Use external resources (Darwin',')'#010+
   '4*2We_Use external resources (Darwin)'#010+
   'A*2We_Use external resources (Darwin)'#010+
-  'P*2','We_Use external resources (Darwin)'#010+
+  'P*2We_Use external resources (Darwin)'#010+
   'p*2We_Use external resources (Darwin)'#010+
   '3*2WF_Specify full-screen type application (EMX, OS/2)'#010+
-  '3*2WG_Specify graphic type application (EMX, OS/2, Windows)'#010+
+  '3*2WG_Specify graphic type appl','ication (EMX, OS/2, Windows)'#010+
   'A*2WG_Specify graphic type application (Windows)'#010+
-  'P*2','WG_Specify graphic type application (Classic Mac OS)'#010+
+  'P*2WG_Specify graphic type application (Classic Mac OS)'#010+
   '3*2Wi_Use internal resources (Darwin)'#010+
   'P*2Wi_Use internal resources (Darwin)'#010+
-  'p*2Wi_Use internal resources (Darwin)'#010+
+  'p*2Wi_Use internal resources (','Darwin)'#010+
   '3*2WN_Do not generate relocation code, needed for debugging (Windows)'#010+
-  'A*2','WN_Do not generate relocation code, needed for debugging (Windows'+
-  ')'#010+
+  'A*2WN_Do not generate relocation code, needed for debugging (Windows)'#010+
   '3*2WR_Generate relocation code (Windows)'#010+
   'A*2WR_Generate relocation code (Windows)'#010+
-  'P*2WT_Specify MPW tool type application (Classic Mac OS)'#010+
-  '3*2WX_Enable executable stack (Lin','ux)'#010+
+  'P*2WT_Spec','ify MPW tool type application (Classic Mac OS)'#010+
+  '3*2WX_Enable executable stack (Linux)'#010+
   'A*2WX_Enable executable stack (Linux)'#010+
   'p*2WX_Enable executable stack (Linux)'#010+
   'P*2WX_Enable executable stack (Linux)'#010+
   '**1X_Executable options:'#010+
-  '**2Xc_Pass --shared/-dynamic to the linker (BeOS, Darwin, FreeBSD, Lin'+
-  'ux)'#010+
-  '**2Xd_Do not use standa','rd library search path (needed for cross comp'+
-  'ile)'#010+
+  '**2Xc_Pass --sha','red/-dynamic to the linker (BeOS, Darwin, FreeBSD, L'+
+  'inux)'#010+
+  '**2Xd_Do not use standard library search path (needed for cross compil'+
+  'e)'#010+
   '**2Xe_Use external linker'#010+
   '**2Xg_Create debuginfo in a separate file and add a debuglink section '+
-  'to executable'#010+
+  'to executable',#010+
   '**2XD_Try to link units dynamically      (defines FPC_LINK_DYNAMIC)'#010+
-  '**2Xi_Use in','ternal linker'#010+
+  '**2Xi_Use internal linker'#010+
   '**2Xm_Generate link map'#010+
   '**2XM<x>_Set the name of the '#039'main'#039' program routine (default i'+
   's '#039'main'#039')'#010+
-  '**2XP<x>_Prepend the binutils names with the prefix <x>'#010+
+  '**2XP<x>_Prepend the binutils names with the pref','ix <x>'#010+
   '**2Xr<x>_Set the linker'#039's rlink-path to <x> (needed for cross comp'+
-  'ile, see',' the ld manual for more information) (BeOS, Linux)'#010+
+  'ile, see the ld manual for more information) (BeOS, Linux)'#010+
   '**2XR<x>_Prepend <x> to all linker search paths (BeOS, Darwin, FreeBSD'+
   ', Linux, Mac OS, Solaris)'#010+
-  '**2Xs_Strip all symbols from executable'#010+
-  '**2XS_Try to link units statically (default, defines ','FPC_LINK_STATIC'+
-  ')'#010+
+  '**2Xs_Strip ','all symbols from executable'#010+
+  '**2XS_Try to link units statically (default, defines FPC_LINK_STATIC)'#010+
   '**2Xt_Link with static libraries (-static is passed to linker)'#010+
   '**2XX_Try to smartlink units             (defines FPC_LINK_SMART)'#010+
   '**1*_'#010+
-  '**1?_Show this help'#010+
+  '**1?_Sh','ow this help'#010+
   '**1h_Shows this help without waiting'
 );
Index: compiler/parser.pas
===================================================================
--- compiler/parser.pas	(revision 16356)
+++ compiler/parser.pas	(working copy)
@@ -65,6 +65,8 @@
          current_asmdata:=nil;
          current_procinfo:=nil;
          current_objectdef:=nil;
+         current_genericdef:=nil;
+         current_specializedef:=nil;
 
          loaded_units:=TLinkedList.Create;
 
@@ -137,6 +139,8 @@
          current_procinfo:=nil;
          current_asmdata:=nil;
          current_objectdef:=nil;
+         current_genericdef:=nil;
+         current_specializedef:=nil;
 
          { unload units }
          if assigned(loaded_units) then
Index: compiler/pdecl.pas
===================================================================
--- compiler/pdecl.pas	(revision 16356)
+++ compiler/pdecl.pas	(working copy)
@@ -443,6 +443,9 @@
            { Generic type declaration? }
            if isgeneric then
              begin
+               if assigned(current_genericdef) then
+                 Message(parser_f_no_generic_inside_generic);
+
                consume(_LSHARPBRACKET);
                generictypelist:=parse_generic_parameters;
                consume(_RSHARPBRACKET);
Index: compiler/pdecobj.pas
===================================================================
--- compiler/pdecobj.pas	(revision 16356)
+++ compiler/pdecobj.pas	(working copy)
@@ -945,10 +945,16 @@
     function object_dec(objecttype:tobjecttyp;const n:tidstring;genericdef:tstoreddef;genericlist:TFPObjectList;fd : tobjectdef) : tobjectdef;
       var
         old_current_objectdef : tobjectdef;
+        old_current_genericdef : tobjectdef;
+        old_current_specializedef : tobjectdef;
       begin
         old_current_objectdef:=current_objectdef;
+        old_current_genericdef:=current_genericdef;
+        old_current_specializedef:=current_specializedef;
 
         current_objectdef:=nil;
+        current_genericdef:=nil;
+        current_specializedef:=nil;
 
         { objects and class types can't be declared local }
         if not(symtablestack.top.symtabletype in [globalsymtable,staticsymtable,objectsymtable]) and
@@ -1002,6 +1008,13 @@
               end;
           end;
 
+        { usage of specialized type inside its generic template }
+        if assigned(genericdef) then
+          current_specializedef:=current_objectdef
+        { reject declaration of generic class inside generic class }
+        else if assigned(genericlist) then
+          current_genericdef:=current_objectdef;
+
         { set published flag in $M+ mode, it can also be inherited and will
           be added when the parent class set with tobjectdef.set_parent (PFV) }
         if (cs_generate_rtti in current_settings.localswitches) and
@@ -1068,6 +1081,8 @@
 
         { restore old state }
         current_objectdef:=old_current_objectdef;
+        current_genericdef:=old_current_genericdef;
+        current_specializedef:=old_current_specializedef;
       end;
 
 end.
Index: compiler/pdecsub.pas
===================================================================
--- compiler/pdecsub.pas	(revision 16356)
+++ compiler/pdecsub.pas	(working copy)
@@ -730,7 +730,9 @@
         popclass : boolean;
         ImplIntf : TImplementedInterface;
         old_parse_generic : boolean;
-        old_current_objectdef: tobjectdef;
+        old_current_objectdef,
+        old_current_genericdef,
+        old_current_specializedef : tobjectdef;
       begin
         { Save the position where this procedure really starts }
         procstartfilepos:=current_tokenpos;
@@ -998,7 +1000,13 @@
               begin
                 symtablestack.push(pd._class.symtable);
                 old_current_objectdef:=current_objectdef;
+                old_current_genericdef:=current_genericdef;
+                old_current_specializedef:=current_specializedef;
                 current_objectdef:=pd._class;
+                if assigned(current_objectdef) and (df_generic in current_objectdef.defoptions) then
+                  current_genericdef:=current_objectdef;
+                if assigned(current_objectdef) and (df_specialization in current_objectdef.defoptions) then
+                  current_specializedef:=current_objectdef;
                 popclass:=true;
               end;
             { Add parameter symtable }
@@ -1010,6 +1018,8 @@
             if popclass then
             begin
               current_objectdef:=old_current_objectdef;
+              current_genericdef:=old_current_genericdef;
+              current_specializedef:=old_current_specializedef;
               symtablestack.pop(pd._class.symtable);
             end;
           end;
@@ -1025,7 +1035,9 @@
         locationstr: string;
         old_parse_generic,
         popclass: boolean;
-        old_current_objectdef: tobjectdef;
+        old_current_objectdef,
+        old_current_genericdef,
+        old_current_specializedef: tobjectdef;
       begin
         locationstr:='';
         pd:=nil;
@@ -1052,12 +1064,20 @@
                              popclass:=true;
                              parse_generic:=(df_generic in pd._class.defoptions);
                              old_current_objectdef:=current_objectdef;
+                             old_current_genericdef:=current_genericdef;
+                             old_current_specializedef:=current_specializedef;
                              current_objectdef:=pd._class;
+                             if assigned(current_objectdef) and (df_generic in current_objectdef.defoptions) then
+                               current_genericdef:=current_objectdef;
+                             if assigned(current_objectdef) and (df_specialization in current_objectdef.defoptions) then
+                               current_specializedef:=current_objectdef;
                            end;
                          single_type(pd.returndef,false,false);
                          if popclass then
                            begin
                              current_objectdef:=old_current_objectdef;
+                             current_genericdef:=old_current_genericdef;
+                             current_specializedef:=old_current_specializedef;
                              symtablestack.pop(pd._class.symtable);
                            end;
                          dec(testcurobject);
Index: compiler/psub.pas
===================================================================
--- compiler/psub.pas	(revision 16356)
+++ compiler/psub.pas	(working copy)
@@ -806,7 +806,9 @@
         old_current_procinfo : tprocinfo;
         oldmaxfpuregisters : longint;
         oldfilepos : tfileposinfo;
-        old_current_objectdef : tobjectdef;
+        old_current_objectdef,
+        old_current_genericdef,
+        old_current_specializedef : tobjectdef;
         templist : TAsmList;
         headertai : tai;
         i : integer;
@@ -1400,14 +1402,21 @@
          old_current_procinfo : tprocinfo;
          old_block_type : tblock_type;
          st : TSymtable;
-         old_current_objectdef : tobjectdef;
+         old_current_objectdef,
+         old_current_genericdef,
+         old_current_specializedef : tobjectdef;
       begin
          old_current_procinfo:=current_procinfo;
          old_block_type:=block_type;
          old_current_objectdef:=current_objectdef;
+         old_current_genericdef:=current_genericdef;
 
          current_procinfo:=self;
          current_objectdef:=procdef._class;
+         if assigned(current_objectdef) and (df_generic in current_objectdef.defoptions) then
+           current_genericdef:=current_objectdef;
+         if assigned(current_objectdef) and (df_specialization in current_objectdef.defoptions) then
+           current_specializedef:=current_objectdef;
 
          { calculate the lexical level }
          if procdef.parast.symtablelevel>maxnesting then
@@ -1514,6 +1523,8 @@
     {$endif state_tracking}
 
          current_objectdef:=old_current_objectdef;
+         current_genericdef:=old_current_genericdef;
+         current_specializedef:=old_current_specializedef;
          current_procinfo:=old_current_procinfo;
 
          { Restore old state }
@@ -1657,7 +1668,9 @@
 
       var
         old_current_procinfo : tprocinfo;
-        old_current_objectdef : tobjectdef;
+        old_current_objectdef,
+        old_current_genericdef,
+        old_current_specializedef : tobjectdef;
         pdflags    : tpdflags;
         pd,firstpd : tprocdef;
         s          : string;
@@ -1665,11 +1678,15 @@
          { save old state }
          old_current_procinfo:=current_procinfo;
          old_current_objectdef:=current_objectdef;
+         old_current_genericdef:=current_genericdef;
+         old_current_specializedef:=current_specializedef;
 
          { reset current_procinfo.procdef to nil to be sure that nothing is writing
            to another procdef }
          current_procinfo:=nil;
          current_objectdef:=nil;
+         current_genericdef:=nil;
+         current_specializedef:=nil;
 
          { parse procedure declaration }
          pd:=parse_proc_dec(isclassmethod, old_current_objectdef);
@@ -1798,6 +1815,8 @@
            end;
 
          current_objectdef:=old_current_objectdef;
+         current_genericdef:=old_current_genericdef;
+         current_specializedef:=old_current_specializedef;
          current_procinfo:=old_current_procinfo;
       end;
 
Index: compiler/ptype.pas
===================================================================
--- compiler/ptype.pas	(revision 16356)
+++ compiler/ptype.pas	(working copy)
@@ -492,8 +492,16 @@
           generate_specialization(def)
         else
           begin
-            if (df_generic in def.defoptions)  then
+            if assigned(current_specializedef) and (def=current_specializedef.genericdef) then
               begin
+                def:=current_specializedef
+              end
+            else if (def=current_genericdef) then
+              begin
+                def:=current_genericdef
+              end
+            else if (df_generic in def.defoptions) then
+              begin
                 Message(parser_e_no_generics_as_types);
                 def:=generrordef;
               end
@@ -633,8 +641,16 @@
                      generate_specialization(def)
                    else
                      begin
-                       if (df_generic in def.defoptions)  then
+                       if assigned(current_specializedef) and (def=current_specializedef.genericdef) then
                          begin
+                           def:=current_specializedef
+                         end
+                       else if (def=current_genericdef) then
+                         begin
+                           def:=current_genericdef
+                         end
+                       else if (df_generic in def.defoptions) then
+                         begin
                            Message(parser_e_no_generics_as_types);
                            def:=generrordef;
                          end
Index: compiler/symdef.pas
===================================================================
--- compiler/symdef.pas	(revision 16356)
+++ compiler/symdef.pas	(working copy)
@@ -632,6 +632,8 @@
 
     var
        current_objectdef : tobjectdef;  { used for private functions check !! }
+       current_genericdef : tobjectdef; { used to reject declaration of generic class inside generic class }
+       current_specializedef : tobjectdef; { used to implement usage of generic class in itself }
 
     { default types }
        generrordef,              { error in definition }
Index: tests/test/tgeneric21.pp
===================================================================
--- tests/test/tgeneric21.pp	(revision 0)
+++ tests/test/tgeneric21.pp	(revision 0)
@@ -0,0 +1,12 @@
+{ %fail }
+{$mode objfpc}{$H+}
+
+type
+  generic TOuter<T> = class(TObject)
+  public type
+    generic TInner<U> = class(TObject)
+    end;
+  end;
+
+begin
+end.
Index: tests/test/tgeneric22.pp
===================================================================
--- tests/test/tgeneric22.pp	(revision 0)
+++ tests/test/tgeneric22.pp	(revision 0)
@@ -0,0 +1,66 @@
+{$mode objfpc}{$H+}
+
+type
+  generic TGListItem<T> = class(TObject)
+  public var
+    FValue: T;
+    FNext: TGListItem;
+    procedure SetValue(Value: T);
+    function GetValue: T;
+    procedure Assign(Source: TGListItem);
+    function Merge(Other: TGListItem): TGListItem;
+  end;
+
+procedure TGListItem.SetValue(Value: T);
+begin
+  FValue := Value;
+end;
+
+function TGListItem.GetValue: T;
+begin
+  Result := FValue;
+end;
+
+procedure TGListItem.Assign(Source: TGListItem);
+begin
+  FNext := Source;
+end;
+
+function TGListItem.Merge(Other: TGListItem): TGListItem;
+var
+  Temp: TGListItem;
+begin
+  Temp := TGListItem.Create;
+  Temp.SetValue(FNext.GetValue + Other.FNext.GetValue);
+  Result := Temp;
+end;
+
+type
+  TIntListItem = specialize TGListItem<Integer>;
+
+var
+  A, A2, B, B2: TIntListItem;
+begin
+  A := TIntListItem.Create;
+  A2 := TIntListItem.Create;
+  A.Assign(A2);
+  if A.FNext <> A2 then
+    halt(1);
+
+  B := TIntListItem.Create;
+  B2 := TIntListItem.Create;
+  B.Assign(B2);
+  if B.FNext <> B2 then
+    halt(1);
+  
+  A2.SetValue(5);
+  if A2.GetValue <> 5 then
+    halt(1);
+  
+  B2.SetValue(7);
+  if B2.GetValue <> 7 then
+    halt(1);
+  
+  if A.Merge(B).GetValue <> 12 then
+    halt(1);
+end.

Aleksa Todorovic

2010-11-18 00:09

reporter   ~0043159

Attached patch adds ability to reference current generic class. Each reference to current generic class is "translated" to appropriate specialization of that generic class. There are two tests as part of the patch to test that it works. The patch, also, rejects declaring generic inside another generic. 0010479 is easy to implement with this patch applied.

Florian

2010-11-24 22:58

administrator   ~0043497

Thanks for the patch. It needed a small addition, you forgot one old_current...:=current_ assignment. Anyways, keep up the good work!

I'll look into the next days into your other generic patches.

Issue History

Date Modified Username Field Change
2008-08-01 20:32 Micha Nelissen New Issue
2008-08-01 20:32 Micha Nelissen FPCOldBugId => 0
2008-08-01 20:33 Micha Nelissen Relationship added child of 0010479
2008-08-01 20:43 Micha Nelissen Note Added: 0021028
2008-08-01 20:43 Micha Nelissen Assigned To => Peter Vreman
2008-08-01 20:43 Micha Nelissen Status new => assigned
2010-08-15 23:38 Ian Hickson Tag Attached: generics
2010-11-17 22:42 Aleksa Todorovic File Added: fpc_bug_11777_generics_self_reference.patch
2010-11-18 00:09 Aleksa Todorovic Note Added: 0043159
2010-11-24 22:58 Florian Fixed in Revision => 16432
2010-11-24 22:58 Florian Status assigned => resolved
2010-11-24 22:58 Florian Fixed in Version => 2.5.1
2010-11-24 22:58 Florian Resolution open => fixed
2010-11-24 22:58 Florian Note Added: 0043497
2010-11-24 22:59 Florian Status resolved => assigned
2010-11-24 22:59 Florian Assigned To Peter Vreman => Florian
2010-11-24 22:59 Florian Status assigned => resolved
2010-11-28 21:34 Florian Relationship added related to 0015477
2011-12-01 11:24 Marco van de Voort Fixed in Version 2.5.1 => 2.6.0